
%% Campbell-Shiller Decomposition

%=======Data Management=======%
cpi= importdata('cpi48018.csv'); %yoy growth rate of price levels
dlogrr = importdata('dlogrr8018.csv'); %log rent growth
logpr  = importdata('logpr8018.csv'); %log price rent ratio
logri  = importdata('logri8018.csv'); %log real interest
rgdpg  = importdata('rgdpg8018.csv'); %real gdp growth rate
logpr_dm  = importdata('logpr_dm8018.csv');
[nobs,nc] = size(dlogrr);
cpi=cpi(2:end,:);
logpr=logpr(2:end,:);
rgdpg=rgdpg(2:end,:);
 
%======= Country VARs =======%
nlags =2; 
PVdlogrr=[];
PVlogri=[];

for ic=1:nc %country
   y  = [dlogrr(:,ic),logri(:,ic), cpi(:,ic), rgdpg(:,ic),logpr(:,ic) ];
   [nobs,nvars] = size(y);
   ydm=0.*y;  
   for j=1:nvars
    ydm(:,j)=y(:,j)-mean(y(:,j));
   end
   retvar = vareb(ydm,nlags);
%construct F matrix
  A = [];
 for j=1:nvars
    A = [A;retvar(j).beta'];
 end
 A(:,end) = []; 
 %re-organize elements of A to get F
  F = [];
  for ilag=1:nlags
    for j=1:nvars
        F(:,(ilag-1)*nvars+j) = A(:,(j-1)*nlags+ilag);
    end
  end
  addF = [eye(nvars*(nlags-1)),zeros(nvars*(nlags-1),nvars)];
  F = [F;addF];
yv = [];
for ilag=1:nlags
    yv = [yv,ydm((nlags-ilag+1):(end-ilag+1),:)];
end
yv = yv';
 rho=1/(1+exp(-log(15))); 
 pvdlogrr = [1,zeros(1,nvars*nlags-1)]*F/(eye(nvars*nlags)-rho*F)*yv;   
pvdlogrr =pvdlogrr';  
 pvlogri = [0,1,zeros(1,nvars*nlags-2)]*F/(eye(nvars*nlags)-rho*F)*yv;   
 pvlogri = pvlogri'; 
 PVdlogrr=[PVdlogrr, pvdlogrr];
 PVlogri=[PVlogri, pvlogri];
end

PVdlogrr_dm = PVdlogrr*0;
 for j=1:nc
   PVdlogrr_dm(:,j)=PVdlogrr(:,j)-mean(PVdlogrr(:,j));
 end
 
 PVlogri_dm = PVlogri*0;
 for j=1:nc
   PVlogri_dm(:,j)=PVlogri(:,j)-mean(PVlogri(:,j));
 end
 
res = PVdlogrr_dm- PVlogri_dm  - logpr_dm(3:end,:);
PVrp_dm=res*0;
for j=1:nc
   PVrp_dm(:,j)=res(:,j)-mean(res(:,j));
end


%csvwrite('PVdlogrr_rho15_logpr_dm.csv',PVdlogrr_dm);
%csvwrite('PVlogri_rho15_logpr_dm.csv',PVlogri_dm);
%csvwrite('PVrp_rho15_logpr_dm.csv',PVrp_dm);
