################################################################################
# Data Management
################################################################################

hprice =  read.csv("housing_price8018.csv" ) #housing_price7619
tt=nrow(hprice)

rent=  read.csv("rent_price8018.csv") #/read.csv("cp.csv")) # cp is consumer price level

logpr=log(hprice )-log(rent )

logpr_dm=sweep(logpr,2,colMeans(logpr),"-")

write.table(logpr_dm, "logpr_dm8018.csv",sep=",",row.names=FALSE, col.names=FALSE)

write.table(logpr, "logpr8018.csv",sep=",",row.names=FALSE, col.names=FALSE)

pr=(hprice )/(rent )
write.table( pr, "pr8018.csv",sep=",",row.names=FALSE, col.names=FALSE)

cpi_level =  read.csv("cpi_index8018.csv" ) #1979-2018 to compute yoy growth

tt=nrow(cpi_level)
cpi4= (( cpi_level[5:tt,] ) - ( cpi_level[1:(tt-4),] ))/( cpi_level[1:(tt-4),] )

cpi4_dm=sweep(cpi4,2,colMeans(cpi4),"-")

write.table(cpi4, "cpi48018.csv",sep=",",row.names=FALSE, col.names=FALSE)

tt=nrow(cpi4)
zzz=log( 1 + cpi4[2:tt,]/4 )  

tt=nrow(rent)
dlogrr =log( rent[2:tt,] ) -log( rent[1:(tt-1),] ) - zzz

dlogrr_dm=sweep(dlogrr,2,colMeans(dlogrr),"-")

write.table(dlogrr, "dlogrr8018.csv",sep=",",row.names=FALSE, col.names=FALSE)

interest =  read.csv("short_interest0818.csv" ) #

tt=nrow(cpi4)
zzz=log( 1 + cpi4[2:tt,]/4 )  

tt=nrow(interest)
logri =log( 1+ interest[2:tt,]/400 ) - zzz

logri_dm=sweep(logri,2,colMeans(logri),"-")

write.table(logri, "logri8018.csv",sep=",",row.names=FALSE, col.names=FALSE)


PVrp_fac =  read.csv("factor_PVrp_rho15_logpr_2.csv" )   
PVrp_lam =  read.csv("lambda_PVrp_rho15_logpr_2.csv" ) 
PVrp_y=read.csv("ydata_PVrp_rho15_logpr_2.csv" )  

fac_dm=sweep(PVrp_fac,2,colMeans(PVrp_fac),"-")
lam=PVrp_lam
y_dm =sweep(PVrp_y,2,colMeans(PVrp_y),"-")

temp=fac_dm$f_1
temp1= lam$lambda
temp2= kronecker((temp),t(temp1) ) 
PVrp_dm_f1=as.data.frame(temp2) 

temp=PVrp_dm_f1%>%select(-V17)

temp= as.data.frame(apply(temp,1,mean)) 
temp1=as.data.frame( temp[3:126, ])
colnames(temp1)="PVrp_dm_nus_avg_f1"

tt=seq(as.Date("1981-09-01"),as.Date("2012-06-01"),by='quarter')
temp1$tt=tt
tt1=seq(as.Date("1981-09-01"),as.Date("2012-06-01"),by='month')
tt1=data.frame(tt1)

temp2 <- sqldf:: sqldf("
                       SELECT distinct  l.*, r.*
                       FROM tt1  as l
                       LEFT JOIN  temp1  as r
                       ON 
                       l.tt1=r.tt 
                       ")%>%select(-tt)

temp3 = zoo::na.approx(temp2[,2]) #1981-09:2012-06
PVrp_rho15a_logpr_2_dm_nus_avg_f1_m_linear=cbind(tt1,temp3)
write.csv(PVrp_rho15a_logpr_2_dm_nus_avg_f1_m_linear,file="PVrp_rho15a_logpr_2_dm_nus_avg_f1_m_linear8112.csv",row.names = F)




