
%% Figure 1

prall= importdata('pr.csv'); 
prall0212=  prall((2001-1980+1)*4+1:(2011-1980+1)*4,:) ; 
startDate = datenum('03-01-2002');
endDate = datenum('12-01-2012');
xData = linspace(startDate,endDate,40);
yDataUS= prall0212(:,end);
yData= prall0212(:,1:end-1);
figure;
plot(xData,yDataUS,'-k','LineWidth',1.6);
hold on;
plot(xData,yData,':r','LineWidth',1.2);
axis tight;
h = gca;
h.XTick = xData(1:4:end);
datetick('x','yy','keepticks')
recessionplot
legend('U.S.','Others');
title('Housing Price-Rent Index in 17 OECD Countries');
xlabel('Year') ;

%%  Figure 2

PVrp_rho15_logpr_dm_f1_us_8118 = importdata('PVrp_rho15_logpr_dm_f1_us_8118.csv');

PVrp_rho15_logpr_dm_us_8118 = importdata('PVrp_rho15_logpr_dm_us_8118.csv');

nt=size(PVrp_rho15_logpr_dm_f1_us_8118,1);
startDate = datenum('01-01-1981');
endDate = datenum('12-01-2018');
xData = linspace(startDate,endDate,nt);
yData= PVrp_rho15_logpr_dm_f1_us_8118;
figure;
plot(xData,yData,'-k','LineWidth',1.5);
hold on;
yData= PVrp_rho15_logpr_dm_us_8118;
plot(xData,yData,'-.r','LineWidth',1.5);
axis tight;
h = gca;
h.XTick = xData(1:4:end);
datetick('x','yy','keepticks')
recessionplot
legend('Common','Local','Location','southeast');
xlabel('Year') ;

%% Figure 3

X=readtable('VARUSm.xlsx');
X =X(209:316,1:end);

[nobs, nvar] = size(X);

VARvnames      = {'PVrp_rho15a_logpr_2_dm_nus_avg_f1_m_linear' ;'ff';'dlogcpi';'dloghp_fhfa';'unrate';'loghpermit';'logconsumer';'gs10';'mortg15_spread_m';'ebp'};
VARnvar=size(VARvnames,1);

VARvnames_long  = {'Common Housing Risk Premium';'Federal Funds Rate';'CPI Inflation';'House Price Growth';'Unemployment Rate';'House Construction';'Consumer Confidence';'10-yr T-Note';'Mortgage Spread';'GZ Bond Spread'};

ENDO = nan(nobs,VARnvar);
for ii=1:VARnvar
    ENDO(:,ii) = X.(VARvnames{ii});
end

det =3;
nlags =1;
% Estimate 
[VAR, VARopt] = VARest(ENDO,nlags,det);
VARopt.vnames = VARvnames;
VARopt.method = 'wild';
VARopt.ndraws = 1000;  
VARopt.pctg = 90;
[IRF, VAR] = IRFcho(VAR,VARopt);
[INF,SUP,MED,BAR] = VARirbandcho(VAR,VARopt);

figure 
for ii=1:VARnvar
    subplot(5,2,ii)
    FigSize(15,10)
    plot( (-100 ).* BAR(:,ii,1),'-k','LineWidth',1.5); hold on; 
    plot((-100 ).*INF(:,ii,1),':k','LineWidth',1); hold on; 
    plot( (-100 ).*SUP(:,ii,1),':k','LineWidth',1); hold on;  
    plot(zeros(VARopt.nsteps),'-b')
    ylabel('%');
    title(VARvnames_long{ii},'FontSize',8)
    axis tight
end


%% Figure 4

[FEVD, VAR] = VARfevdcho(VAR,VARopt);
[FEVDINF,FEVDSUP,FEVDMED] = VARfevdbandcho(VAR,VARopt);

figure 
for ii=1:VARnvar
    subplot(5,2,ii)
    FigSize(15,10)
    plot( (100 ).*FEVDMED(:,1,ii),'-k','LineWidth',1.5); hold on; 
    plot((100 ).*FEVDINF(:,1,ii),':k','LineWidth',1); hold on; 
    plot( (100 ).*FEVDSUP(:,1,ii),':k','LineWidth',1); hold on; 
    plot(zeros(VARopt.nsteps),'-b')
    ylabel('%');
    title(VARvnames_long{ii},'FontSize',8)
    axis tight
end


