function [VAR, VARopt] = VARest(ENDO,nlag,const)


%% Check inputs
%===============================================
[nobs, nvar] = size(ENDO);

% Create VARopt and update it
VARopt = VARsetup;
VAR.ENDO = ENDO;
VAR.nlag = nlag;

% Check if ther are constant, trend, both, or none
%if ~exist('const','var')
%    const = 1;
%end
VAR.const = const;


%% Save some parameters and create data matrices
%===============================================
    nobse         = nobs -  nlag ;
    VAR.nobs      = nobse;
    VAR.nvar      = nvar;
    VAR.nlag      = nlag;
    ncoeff        = nvar*nlag; 
    VAR.ncoeff    = ncoeff;
    ntotcoeff     = ncoeff +   const;
    VAR.const     = const;

% Create independent vector and lagged dependent matrix
[Y, X] = VARdata(ENDO,nlag,const);


%% Compute the matrix of coefficients & VCV
%===============================================
Ft = (X'*X)\(X'*Y);
VAR.Ft = Ft;
SIGMA = (1/(nobse-ntotcoeff))*(Y-X*Ft)'*(Y-X*Ft); % adjusted for # of estimated coeff per equation
VAR.sigma = SIGMA;
VAR.residuals = Y - X*Ft;
VAR.X = X;
VAR.Y = Y;


%% Companion matrix of Ft' and max eigenvalue
%===============================================
F = Ft';
Fcomp = [F(:,1+const:nvar*nlag+const); eye(nvar*(nlag-1)) zeros(nvar*(nlag-1),nvar)];
VAR.Fcomp = Fcomp;
VAR.maxEig = max(abs(eig(Fcomp)));

%% Initialize other results
%===============================================
VAR.invA = [];  % inverse of teh A matrix (need identification: see VARir/VARfevd)
VAR.S    = [];  % Orthonormal matrix (need identification: see SR)


